function y = BisecBSV(S,K,r,q,T,a,b,PutCall,Price,tol,maxiter)

lo = Price - BSPrice(S,K,r,q,T,a,PutCall);
hi = Price - BSPrice(S,K,r,q,T,b,PutCall);

if (lo*hi > 0)
    y = -1;
else
	for i=1:maxiter
		m = (a+b)/2;
		mid = Price - BSPrice(S,K,r,q,T,m,PutCall);
		if (abs(mid)<tol)
			y = m;
			break
			return
		elseif (mid>0)
			a = m;
		else
			b = m;
		end
	end
end

y = m;

